/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_mult_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_0<NslNumType,NslTypeId>_mult_library.h
//
/*
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator^(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator^(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator^(const NslNumType,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);

extern void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

extern void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

*/

// nsl_num_0<NslNumType,NslTypeId> multiplication
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const NslFloat0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const NslDouble0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const NslInt0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() * b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const double a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (NslNumType) " << a << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a * b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator^(const int a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator^\n";
	cout << "// (NslNumType) " << a << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a * b.get_data();
	return c;
}

// mult_equal

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const float& b)
{
	out.elem() = a.get_data() * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const double& b)
{
	out.elem() = a.get_data() * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const int& b)
{
	out.elem() = a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const NslFloat0& b)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i] * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const NslDouble0& b)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i] * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const NslInt0& b)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i] * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int amax = a.get_imax();

	out = 0;
	for (int i = 0; i < amax; i++)
		out = out + a[i] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	out = 0;
	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out = out + a[i][j] * b[i][j];
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslFloat0& b)
{
	out.elem() = a.get_data() * b.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslDouble0& b)
{
	out.elem() = a.get_data() * b.get_data();
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslInt0& b)
{
	out.elem() = a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bmax = b.get_imax();

	out = 0;
	for (int i = 0; i < bmax; i++)
		out = out + a * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	out = 0;
	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		out = out + a * b[i][j];
}

// mult_plus

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const float b)
{
	out.elem() += a.get_data() * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const double b)
{
	out.elem() += a.get_data() * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const int b)
{
	out.elem() += a.get_data() * b;
}
template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out + a[i] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out + a[i] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	out.elem() += a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bmax = b.get_imax();

	for (int i = 0; i < bmax; i++)
		out = out + a.get_data() * b[i];
}

// mult_minus

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,const NslNumType& b)
{
	out.elem() -= a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out - a[i] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int amax = a.get_imax();

	for (int i = 0; i < amax; i++)
		out = out - a[i] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	out.elem() -= a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_0<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bmax = b.get_imax();

	for (int i = 0; i < bmax; i++)
		out = out - a.get_data() * b[i];
}

