/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_ramp_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_0<NslNumType,NslTypeId>_ramp_library.h        */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType);
extern nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType,
	const NslNumType,const NslNumType);
*/

// if a > 0 then a else 0

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>& a) 
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > (NslNumType) 0)
		c = a;
	else
		c = 0;
	return c;
}

// if a > b then a - b else 0

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>& a,const NslNumType b)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > b)
		c = a - b;
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > b)
		c = a - b;
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>& a,const NslNumType b,
	const NslNumType y1,const NslNumType y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > b)
		c = a - b + y2;
	else
		c = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLramp(const nsl_num_0<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > b)
		c = a - b + y2;
	else
		c = y1;
	return c;
}

