//
// nsl_str_data_comp_library.h
//

# include "nsl_all_kernel_include.h"

// equal 

int operator==(const NslString0& a, const char* b)
{
	if(strcmp(a.get_data(),b) == 0)
		return 1;
	else
		return 0;
}

int operator==(const char* a, const NslString0& b)
{
	if(strcmp(a,b.get_data()) == 0)
		return 1;
	else
		return 0;
}

int operator==(const NslString0& a, const NslString0& b)
{
	if(strcmp(a.get_data(),b.get_data()) == 0)
		return 1;
	else
		return 0;
}

// not equal 

int operator!=(const NslString0& a, const char* b)
{
	if(strcmp(a.get_data(),b) != 0)
		return 1;
	else
		return 0;
}

int operator!=(const char* a, const NslString0& b)
{
	if(strcmp(a,b.get_data()) != 0)
		return 1;
	else
		return 0;
}

int operator!=(const NslString0& a, const NslString0& b)
{
	if(strcmp(a.get_data(),b.get_data()) != 0)
		return 1;
	else
		return 0;
}

// equal 

int nslEqual(const NslString0& a, const char* b, int len)
{
	if (len <= 0) {
		if(strcmp(a.get_data(),b) == 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a.get_data(),b,len) == 0)
			return 1;
		else
			return 0;
	}
}

int nslEqual(const char* a, const NslString0& b, int len)
{
	if (len <= 0) {
		if(strcmp(a,b.get_data()) == 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a,b.get_data(),len) == 0)
			return 1;
		else
			return 0;
	}
}

int nslEqual(const NslString0& a, const NslString0& b, int len)
{
	if (len <= 0) {
		if(strcmp(a.get_data(),b.get_data()) == 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a.get_data(),b.get_data(),len) == 0)
			return 1;
		else
			return 0;
	}
}

// not equal 

int nslNotEqual(const NslString0& a, const char* b, int len)
{
	if (len <= 0) {
		if(strcmp(a.get_data(),b) != 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a.get_data(),b,len) != 0)
			return 1;
		else
			return 0;
	}
}

int nslNotEqual(const char* a, const NslString0& b, int len)
{
	if (len <= 0) {
		if(strcmp(a,b.get_data()) != 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a,b.get_data(),len) != 0)
			return 1;
		else
			return 0;
	}
}

int nslNotEqual(const NslString0& a, const NslString0& b, int len)
{
	if (len <= 0) {
		if(strcmp(a.get_data(),b.get_data()) != 0)
			return 1;
		else
			return 0;
	} else {
		if(strncmp(a.get_data(),b.get_data(),len) != 0)
			return 1;
		else
			return 0;
	}
}



