/* SCCS  %W%---%E%--%U% */
//
// 	xnsl_temporal_graph.h
//

class xnsl_temporal_graph : public xnsl_graph
{
protected:
	int pulsefg;
	num_type _t0,_t1;		// time range 
public:
	xnsl_temporal_graph(xnsl_display_canvas* = 0);
	virtual ~xnsl_temporal_graph();

	void set_t0(num_type t) { _t0 = t; }
	void set_t1(num_type t) { _t1 = t; }

	num_type get_t0() { return _t0; }
	num_type get_t1() { return _t1; }

        virtual xnsl_widget *make_widget();

        virtual int display();
        virtual int display_temporal_graph(xnsl_widget* = 0,int=0,int=0,int=10,int=10,
		int=10,int=10, num_type = 0.0, num_type = 1.0);
 
	virtual int	read_from_database();
	virtual int	write_to_database();
	virtual int	print(ostream&) const;
 	virtual	int	input(int,int,int);
	virtual	int	output(int,int);
};
/*
template<class NslType>
xnsl_temporal_graph<NslType>::xnsl_temporal_graph(xnsl_display_canvas* win) : 
	xnsl_graph<NslType>(win)
{
        set_type("temporal_graph");

//	pulsefg = 0;
	_t0 = 0;
	_t1 = 0;

//	set_menu_canvas_events(canvas);
//	parent_canvas->set_clear_fg(0);
}
template<class NslType>
xnsl_temporal_graph<NslType>::~xnsl_temporal_graph()  
{
}

template<class NslType>
xnsl_widget * xnsl_temporal_graph<NslType>::make_widget ()
{
	cmd_error("xnsl_area_level_graph: CANNOT create widget");
        return 0;
}

template<class NslType>
int xnsl_temporal_graph<NslType>::display()
{
//	display_temporal_graph(_widget,_wx0,_wy0,_wx1,_wy1,_wxs,_wys,_wymin,_wymax);

 	return 1;
}
template<class NslType>
int xnsl_temporal_graph<NslType>::display_temporal_graph(xnsl_widget*,
	int,int,int,int,int,int,num_type, num_type)
{
 	return 1;
}

template<class NslType>
int xnsl_temporal_graph<NslType>::read_from_database()
{
	return 1;
}
template<class NslType>
int xnsl_temporal_graph<NslType>::write_to_database()
{
	return 1;
}
template<class NslType>
int xnsl_temporal_graph<NslType>::input(int,int,int) // int x_pos,int y_pos,int fg)
{
	return 1;
}
template<class NslType>
int xnsl_temporal_graph<NslType>::output(int,int) // int x_pos,int y_pos)
{
	return 1;
}
template<class NslType>
int xnsl_temporal_graph<NslType>::print(ostream&) const
{
	return 1;
}


*/