/* SCCS  %W%---%E%--%U% */
//
//	nsl_num_0.h
//

template<class NslNumType,int NslTypeId>
class nsl_num_0 : public nsl_data_layer
{
protected:
	NslNumType v; 
public:
	nsl_num_0(const NslNumType val = 0,int=0,int=1,int = 1); // 0,1
	nsl_num_0(const char*, nsl_public* = 0,int=0,int=1,int=1);
	nsl_num_0(const char*, const NslNumType, nsl_public* = 0,
		int=0,int=1,int=1);
//	nsl_num_0(const nsl_num_0<NslNumType,NslTypeId>&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslFloat0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDouble0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslInt0&,int=0,int=1,int=1); // 0,1
/*	nsl_num_0(const NslDinFloat0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDinDouble0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDinInt0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDoutFloat0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDoutDouble0&,int=0,int=1,int=1); // 0,1
	nsl_num_0(const NslDoutInt0&,int=0,int=1,int=1); // 0,1
*/	~nsl_num_0(void);

	void initialize(const char*, nsl_public* = 0,int=0,int=1,int=1);

	int	init_num_data();
	int memAlloc();
	
	NslNumType get_data() 	const { return v; }
	NslNumType getData() 	const { return v; }
	NslNumType get_value() 	const { return v; }
	NslNumType getValue() 	const { return v; }
	NslNumType& elem() { return v; } 	

//	void	set_value(const NslNumType);
	void	set_value(float);
	void	set_value(double);
	void	set_value(int);

// add
	nsl_num_0<NslNumType,NslTypeId> operator+() const;
	nsl_num_0<NslNumType,NslTypeId> operator+(const nsl_num_0<NslNumType,NslTypeId>&) const;
	nsl_num_0<NslNumType,NslTypeId> operator+(const NslNumType) const;

// assignment
	NslNumType 	operator=(const NslFloat0&);
	NslNumType 	operator=(const NslDouble0&);
	NslNumType 	operator=(const NslInt0&);
//	NslNumType 	operator=(const nsl_din_num_0<NslNumType,NslTypeId>&);
//	NslNumType 	operator=(const nsl_dout_num_0<NslNumType,NslTypeId>&);
	NslNumType 	operator=(const float);
	NslNumType 	operator=(const double);
	NslNumType 	operator=(const int);

// print

	virtual int	nslPrint() const;
	int	print_num_data() const;
	virtual int	nslStatus() const;
	int	print_num_data_status() const;

	virtual int	print(ostream&) const;
	int	print_num_data(ostream&) const;
	virtual int	print_status(ostream&) const;
	int	print_num_data_status(ostream&) const;

	int 	reset_num_data(nsl_buffer* = 0);
	virtual int 	reset(nsl_buffer* = 0);

	int 	write_num_data(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_num_data(nsl_buffer&);
	virtual int 	read(nsl_buffer&);

	int 	write_num_data(nsl_char_buf&);
	virtual int 	write(nsl_char_buf&);
	int 	read_num_data(nsl_char_buf&);
	virtual int 	read(nsl_char_buf&);
};

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslNumType val,int sfg,int fg,int rfg) : 
	nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = val;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const char* str,
	nsl_public* m,int sfg,int fg,int rfg) : 
	nsl_data_layer("num_data",str,m,sfg,fg,rfg)
{
	init_num_data();
	v = 0;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const char* str,
	const NslNumType val,nsl_public* m,int sfg,int fg,int rfg) : 
	nsl_data_layer("num_data",str,m,sfg,fg,rfg)
{
	init_num_data();
	v = val;
}
/*
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const nsl_num_0<NslNumType,NslTypeId>& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
*/
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslFloat0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDouble0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslInt0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
/*
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDinFloat0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDinDouble0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDinInt0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDoutFloat0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDoutDouble0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::nsl_num_0(const NslDoutInt0& a,
	int sfg,int fg,int rfg) : nsl_data_layer(sfg,fg,rfg)
{
	init_num_data();
	v = a.get_value();
}
*/
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId>::~nsl_num_0(void)
{
}

template<class NslNumType, int NslTypeId>
void nsl_num_0<NslNumType,NslTypeId>::initialize(const char* str,
	nsl_public* m,int sfg,int fg,int rfg)
{
	nsl_data_layer::initialize("num_data",str,m,sfg,fg,rfg);
	init_num_data();
	v = 0;
}

// init

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::init_num_data()
{
	set_type_id(NslTypeId);

	v = 0;
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::memAlloc()
{
	v = 0;
	return 1;
}

// nsl_num_0 set values
template<class NslNumType, int NslTypeId>
void nsl_num_0<NslNumType,NslTypeId>::set_value(float val)
{
	v = (NslNumType) val;
}
template<class NslNumType, int NslTypeId>
void nsl_num_0<NslNumType,NslTypeId>::set_value(double val)
{
	v = (NslNumType) val;
}
template<class NslNumType, int NslTypeId>
void nsl_num_0<NslNumType,NslTypeId>::set_value(int val)
{
	v = (NslNumType) val;
}

// nsl_num_0<NslNumType,NslTypeId> addition

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> nsl_num_0<NslNumType,NslTypeId>::operator+() const
{
	nsl_num_0<NslNumType,NslTypeId> c;
	c = get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> nsl_num_0<NslNumType,NslTypeId>::operator+(const 
	nsl_num_0<NslNumType,NslTypeId>& b) const
{
	nsl_num_0<NslNumType,NslTypeId> c;
	c = get_data() + b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> nsl_num_0<NslNumType,NslTypeId>::operator+(const 
	NslNumType b) const
{
	nsl_num_0<NslNumType,NslTypeId> c;
	c = get_data() + b;
	return c;
}

// nsl_num_0<NslNumType,NslTypeId> assignment

template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const NslFloat0& a)
{
	v = (NslNumType) a.get_value();

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const NslDouble0& a)
{
	v = (NslNumType) a.get_value();

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const NslInt0& a)
{
	v = (NslNumType) a.get_value();

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const float a)
{
	v = (NslNumType) a;

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const double a)
{
	v = (NslNumType) a;

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
template<class NslNumType, int NslTypeId>
NslNumType nsl_num_0<NslNumType,NslTypeId>::operator=(const int a)
{
	v = (NslNumType) a;

	if (TRACE_FG == 1 && NSL_FILE != NULL && m_parent != NULL && m_parent != SYSTEM)
	{
		m_parent->print(*NSL_FILE);
		print(*NSL_FILE);
	}

	return v;
}
// print

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print_num_data_status() const
{
	print_data_layer_status();
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::nslStatus() const
{
	print_num_data_status();
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print_num_data() const
{
	if (sub_layer_fg == 0)
		print_data_layer();

	NSLoutput("\t",v);
	NSLoutput(" ");

	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::nslPrint() const
{
	print_num_data();
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print_num_data_status(ostream& out) const
{
	print_data_layer_status(out);
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print_status(ostream& out) const
{
	print_num_data_status(out);
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print_num_data(ostream& out) const
{
	if (sub_layer_fg == 0)
		print_data_layer(out);

	NSLoutput(v,out);
	NSLoutput(" ",out);

	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::print(ostream& out) const
{
	print_num_data(out);
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::reset_num_data(nsl_buffer* buf)
{
	if (buf == NULL)
		v = 0;
	else
		*buf >> (NslNumType) v;

	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::reset(nsl_buffer* buf)
{
	reset_num_data(buf);
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::write_num_data(nsl_buffer& buf)
{
	buf << (NslNumType) v;
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::write(nsl_buffer& buf)
{
	write_num_data(buf);
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::read_num_data(nsl_buffer& buf)
{
	buf >> (NslNumType) v;
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::read(nsl_buffer& buf)
{
	read_num_data(buf);
	return 1;
}

template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::write_num_data(nsl_char_buf& buf)
{
	sprintf(buf.get_sbuf(),"%f", (NslNumType) v);
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::write(nsl_char_buf& buf)
{
	write_num_data(buf);
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::read_num_data(nsl_char_buf& buf)
{
	buf >> (NslNumType) v;
	return 1;
}
template<class NslNumType, int NslTypeId>
int nsl_num_0<NslNumType,NslTypeId>::read(nsl_char_buf& buf)
{
	read_num_data(buf);
	return 1;
}
