/* SCCS  @(#)nsl_char_buf_stream_library.h	1.1---95/08/13--23:38:36 */
//
// nsl_char_buf_stream_library.h
//

extern 	nsl_char_buf& operator>>(nsl_char_buf&,char&);
extern 	nsl_char_buf& operator<<(nsl_char_buf&,char);

extern 	nsl_char_buf& operator>>(nsl_char_buf&,char*); // str
extern 	nsl_char_buf& operator<<(nsl_char_buf&,const char*); // str

extern 	nsl_char_buf& operator>>(nsl_char_buf&,int&);
extern 	nsl_char_buf& operator<<(nsl_char_buf&,int);

extern 	nsl_char_buf& operator>>(nsl_char_buf&,float&);
extern 	nsl_char_buf& operator<<(nsl_char_buf&,float);

extern 	nsl_char_buf& operator>>(nsl_char_buf&,double&);
extern 	nsl_char_buf& operator<<(nsl_char_buf&,double);

extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_layer&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_data_layer&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_int_data&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_num_data&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_str_data&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_ptr_data&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_vector_layer&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_int_vector&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_num_vector&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_str_vector&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_ptr_vector&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_matrix_layer&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_int_matrix&);
//extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_num_matrix&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_str_matrix&);
extern nsl_char_buf& operator>>(nsl_char_buf&,nsl_ptr_matrix&);

extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_layer&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_data_layer&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_int_data&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_num_data&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_str_data&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_ptr_data&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_vector_layer&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_int_vector&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_num_vector&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_str_vector&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_ptr_vector&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_matrix_layer&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_int_matrix&);
//extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_num_matrix&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_str_matrix&);
extern nsl_char_buf& operator<<(nsl_char_buf&,nsl_ptr_matrix&);

template<class NslNumType, int NslTypeId>
nsl_char_buf& operator>>(nsl_char_buf& buf,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	layer.read_num_data(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_char_buf& operator<<(nsl_char_buf& buf,nsl_num_0<NslNumType,NslTypeId>& layer)
{
	layer.write_num_data(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_char_buf& operator>>(nsl_char_buf& buf,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	layer.read_num_vector(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_char_buf& operator<<(nsl_char_buf& buf,nsl_num_1<NslNumType,NslTypeId>& layer)
{
	layer.write_num_vector(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_char_buf& operator>>(nsl_char_buf& buf,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	layer.read_num_matrix(buf);

	return buf;
}
template<class NslNumType, int NslTypeId>
nsl_char_buf& operator<<(nsl_char_buf& buf,nsl_num_2<NslNumType,NslTypeId>& layer)
{
	layer.write_num_matrix(buf);

	return buf;
}

// iostream

extern 	nsl_char_buf& operator<<(nsl_char_buf&,istream&);
extern 	nsl_char_buf& operator>>(nsl_char_buf&,ostream&);
extern 	nsl_char_buf& operator<<(nsl_char_buf&,fstream&);
extern 	nsl_char_buf& operator>>(nsl_char_buf&,fstream&);

extern istream& operator>>(istream&,nsl_char_buf&);
extern ostream& operator<<(ostream&,nsl_char_buf&);
extern fstream& operator>>(fstream&,nsl_char_buf&);
extern fstream& operator<<(fstream&,nsl_char_buf&);
