/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_div_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_0<NslNumType,NslTypeId>_div_library.h
//
/*
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator/(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator/(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator/(const NslNumType,const nsl_num_0<NslNumType,NslTypeId>&);
*/

// nsl_num_0<NslNumType,NslTypeId> pointwise division
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const NslFloat0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a.get_data() / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const NslInt0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a.get_data() / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const NslDouble0& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a.get_data() / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	if (b != 0)
		c = a.get_data() / b;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	if (b != 0)
		c = a.get_data() / b;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (data) " << a.get_name() << " / (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	if (b != 0)
		c = a.get_data() / b;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const float a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const double a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator/(const int a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator/\n";
	cout << "// (NslNumType) " << a << " / (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	NslNumType d;
	if ((d = b.get_data()) != 0)
		c = a / d;
	else
		cmd_error("DIVISION by 0");
	return c;
}

