/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_sub_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_0<NslNumType,NslTypeId>_sub_library.h
//
/*
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator-(const nsl_num_0<NslNumType,NslTypeId>&);
extern 	nsl_num_0<NslNumType,NslTypeId> 	operator-(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator-(const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_0<NslNumType,NslTypeId> 	operator-(const NslNumType,const nsl_num_0<NslNumType,NslTypeId>&);
*/

// nsl_num_0<NslNumType,NslTypeId> subtruction
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (data) "<< " = - (data) ";
	cout << a.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = -a.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b) // NslFloat0& 
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (data) " << a.get_name() << " - (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() - b.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (data) " << a.get_name() << " - (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() - b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (data) " << a.get_name() << " - (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() - b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (data) " << a.get_name() << " - (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a.get_data() - b;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> operator-(const NslNumType a, const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_0<NslNumType,NslTypeId>  operator-\n";
	cout << "// (NslNumType) " << a << " - (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	nsl_num_0<NslNumType,NslTypeId> c;
	c = a - b.get_data();
	return c;
}



