/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_gauss_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_1<NslNumType,NslTypeId>_gauss_library.h                  */
/*                                                            	*/
/****************************************************************/

//extern nsl_num_1<NslNumType,NslTypeId> NSLgauss(const nsl_num_0<NslNumType,NslTypeId>&,const int);

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLgauss(const nsl_num_0<NslNumType,NslTypeId>& sig,const int xn)
{
	nsl_num_1<NslNumType,NslTypeId> c(xn);
	float m = xn/2;

	for (int i=0; i < xn; i++)
	    c.elem(i) = (float) exp(-(i-m)*(i-m)/
			(2*sig.get_data()*sig.get_data()));

	return c;
}
