/* SCCS  @(#)nsl_vector_sigmoid_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*					nsl_vector_sigmoid_library.h					*/
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		c[i] = ((NslNumType)1.0 / ((NslNumType)1.0 + exp(-a[i])));

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& x1,
	const nsl_num_1<NslNumType,NslTypeId>& x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		c[i] = 1.0 / (1.0 + exp(-(a[i]-x1[i])/(x2[i]-x1[i])));

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType x1,const NslNumType x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		c[i] = 1.0 / (1.0 + exp(-(a[i]-x1)/(x2-x1)));

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigmoid(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		c[i] = 1.0 / (1.0 + exp(-(a[i]-x1.get_data())/(x2.get_data()-x1.get_data())));

	return c;
}
