/* SCCS  %W%---%E%--%U% */
//
// nsl_streambuf_stream_library.C
//

# include "nsl_all_kernel_include.h"

// operators

// << char >>

nsl_streambuf& operator>>(nsl_streambuf& buf,char& c)
{
	buf.get(c);

	return buf;
}
nsl_streambuf& operator<<(nsl_streambuf& buf,char c)
{
	buf.put(c); 

	return buf;
}

// << string >>

nsl_streambuf& operator<<(nsl_streambuf& buf,const char* str)
{
	int i = 0;

	int len = strlen(str);

	while (i <= len)
		buf << str[i++];

	if (len > 0)
		buf.incr_str_cnt();
		
	return buf;
}
nsl_streambuf& operator>>(nsl_streambuf& buf,char* str)
{
	int start_char_cnt = buf.get_char_cnt(); // initial char count

	char c = 0;
	int i = 0;
	int flag = 0;
	int mode = buf.get_mode();

	buf >> c;
	// AW2000: get rid of brackets used in NSLS as data value separators
	while (c == '{' || c == '}') // ||  (buf.get_state() == 1 && (c == '\0' || c == ' ' || c == '\t'))) 
	{
		flag = 1;
		buf >> c;
		while ((c == '\0' || c == ' ' || c == '\t')) //buf.get_state() == 1 && 
		{
			if (flag == 1)
			{
				if (mode == 0) // retrieve 
					buf.decr_str_cnt();
				else if (mode == 1) // keep old count 
					buf.set_char_cnt(start_char_cnt);
			}
			flag = 0;
			buf >> c;
		}
	}

	while (c != '\0' && c != ' ' && c != '\t' && c != '{' && c != '}')
	{
		str[i++] = c;
		buf >> c;
	}

	str[i] = '\0'; // finish string

	if (i > 0) // || flag == 1)
	{
	    if (mode == 0) // retrieve 
			buf.decr_str_cnt();
	    else if (mode == 1) // keep old count 
			buf.set_char_cnt(start_char_cnt);
	}

	return buf;
}

