/* SCCS  @(#)nsl_matrix_max_library.C	1.1---95/08/13--20:48:17 */
//
//	nsl_matrix_max_library.C
//
/*
# include "nsl_all_kernel_include.h"

num_type NSLmax(const nsl_matrix& a) 
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();

	nsl_num_data c;
	c = 0;

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > c)
			c = a[i][j];
	return c.get_data();
}

// if a > b then a else b

nsl_matrix NSLmax(const nsl_matrix& a,const nsl_matrix& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_matrix c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j];
		else
			c[i][j] = b[i][j];
	return c;
}
nsl_matrix NSLmax(const nsl_matrix& a,const nsl_data& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();

	nsl_matrix c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b.get_data();
	return c;
}
nsl_matrix NSLmax(const nsl_matrix& a,const num_type b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_matrix c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j];
		else
			c[i][j] = b;
	return c;
}
*/