//
//	nsl_neural_network.C
//

# include "nsl_all_kernel_include.h"
# include "nsl_all_neuron_include.h"

nsl_neural_network::nsl_neural_network(const char* str,int fg) : 
	nsl_model(str,fg)
{
	set_type("neural_network");
}
nsl_neural_network::~nsl_neural_network()
{
}

int nsl_neural_network::run()
{
	nsl_model::run(); 	// run modules

	nsl_layer* layer;

	if (layer_list != NULL)
	{
	   layer_list->wind_up(); 
	   while ((layer = (nsl_layer*)layer_list->next()) != NULL)
	   {
		if (CURRENT_TIME == 0)
			layer->init();
		else
			layer->run();
	   }
	}
	else
	   cmd_out("NULL layer_list");

	return 1;
}
